.\"	$NetBSD: getent.1,v 1.18 2009/03/11 13:53:09 joerg Exp $
.\"
.\" Copyright (c) 2004 The NetBSD Foundation, Inc.
.\" All rights reserved.
.\"
.\" This code is derived from software contributed to The NetBSD Foundation
.\" by Luke Mewburn.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE NETBSD FOUNDATION, INC. AND CONTRIBUTORS
.\" ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
.\" TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
.\" PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE FOUNDATION OR CONTRIBUTORS
.\" BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
.\" CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
.\" SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
.\" INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
.\" CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
.\" ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
.\" POSSIBILITY OF SUCH DAMAGE.
.\"
.Dd May 14, 2008
.Dt GETENT 1
.Os
.Sh NAME
.Nm getent
.Nd get entries from administrative database
.Sh SYNOPSIS
.Nm
.Ar database
.Op Ar key ...
.Sh DESCRIPTION
The
.Nm
program retrieves and displays entries from the administrative
database specified by
.Ar database ,
using the lookup order specified in
.Xr nsswitch.conf 5 .
The display format for a given
.Ar database
is as per the
.Dq traditional
file format for that database.
.Pp
.Ar database
may be one of:
.Bl -column "protocols" "user:passwd:uid:gid:gecos:home_dir:shell" -offset indent -compact
.It Sy Database Ta Sy Display format
.It disktab Ta entry
.It ethers Ta address name
.It gettytab Ta entry
.It group Ta group:passwd:gid:[member[,member]...]
.It hosts Ta address name [alias ...]
.It netgroup Ta (host,user,domain) [...]
.It networks Ta name network [alias ...]
.It passwd Ta user:passwd:uid:gid:gecos:home_dir:shell
.It printcap Ta entry
.It protocols Ta name protocol [alias ...]
.It rpc Ta name number [alias ...]
.It services Ta name port/protocol [alias ...]
.It shells Ta /path/to/shell
.It termcap Ta entry
.El
.Pp
If one or more
.Ar key
arguments are provided, they will be looked up in
.Ar database
using the appropriate function.
For example,
.Sy passwd
supports a numeric UID or user name;
.Sy hosts
supports an IPv4 address, IPv6 address, or host name;
and
.Sy services
supports a service name, service name/protocol name, numeric port, or
numeric port/protocol name.
.Pp
If no
.Ar key
is provided and
.Ar database
supports enumeration, all entries for
.Ar database
will be retrieved using the appropriate enumeration function and printed.
.Pp
For 
.Xr cgetcap 3
style databases (
.Sy disktab ,
.Sy printcap ,
.Sy termcap )
specifying a key, lists the entry for that key, and specifying more arguments
after the key are used as fields in that key, and only the values of the keys
are returned.
For boolean keys
.Dv true
is returned if the key is found. If a key is not found, then
.Dv false
is always
returned.
.Sh DIAGNOSTICS
.Nm
exits 0 on success,
1 if there was an error in the command syntax,
2 if one of the specified key names was not found in
.Ar database ,
or 3 if there is no support for enumeration on
.Ar database .
.Sh SEE ALSO
.Xr cgetcap 3 ,
.Xr disktab 5 ,
.Xr ethers 5 ,
.Xr gettytab 5 ,
.Xr group 5 ,
.Xr hosts 5 ,
.Xr networks 5 ,
.Xr nsswitch.conf 5 ,
.Xr passwd 5 ,
.Xr protocols 5 ,
.Xr printcap 5 ,
.Xr rpc 5 ,
.Xr services 5 ,
.Xr shells 5 ,
.Xr termcap 5
.Sh HISTORY
A
.Nm
command appeared in
.Nx 3.0 .
It was based on the command of the same name in
.Tn Solaris
and
.Tn Linux .
